
minetest.register_craftitem("fnaf:balloons", {
	description = "Balloons",
	inventory_image = "balloon.png",
})

fnaf:register_mob("fnaf:balloon_boy", {
	type = "animal",
	hp_max = 50,
	collisionbox = {-0.4, -0.50, -0.4, 0.4, 0.50, 0.4},
	visual = "mesh",
	mesh = "human.x",
	textures = {"balloon_boy.png"},
	visual_size = {x=1, y=0.50},
	makes_footstep_sound = true,
	view_range = 15,
	walk_velocity = 1,
	run_velocity = 1.5,
	damage = 1,
	drops = {
		{name = "fnaf:balloon",
		chance = 1,
		min = 1,
		max = 4,},
	},
	armor = 150,
	drawtype = "front",
	water_damage = 0,
	lava_damage = 0,
	light_damage = 0,
	on_rightclick = nil,
	attack_type = "dogfight",
	animation = {
		speed_normal = 15,
		speed_run = 15,
		stand_start = 0,
		stand_end = 79,
		walk_start = 168,
		walk_end = 188,
		run_start = 168,
		run_end = 188,
		punch_start = 0,
		punch_end = 79,
	},

})

minetest.register_craftitem("fnaf:spawn_balloon_boy", {
	description = "Spawn Balloon Boy",
	inventory_image = "spawn_bb.png",
	liquids_pointable = false,
	stack_max = 99,
	on_place = function(itemstack, placer, pointed_thing)
		if pointed_thing.type == "node" then
			local p = pointed_thing.above
			p.y = p.y+1
			minetest.env:add_entity(p, "fnaf:balloon_boy")
			if not minetest.setting_getbool("creative_mode") then itemstack:take_item() end
			return itemstack
		end
	end,
})

minetest.register_node("fnaf:spawner_balloon_boy", {
	description = "Balloon Boy Spawner",
	paramtype = "light",
	tiles = {"balloon_boy_spawner.png"},
	is_ground_content = true,
	drawtype = "allfaces",
	groups = {cracky=1,level=1},
	drop = "default:steel_ingot",
})


minetest.register_abm({
	nodenames = {"fnaf:spawner_balloon_boy"},
	interval = 2.0,
	chance = 20,
	action = function(pos, node, active_object_count, active_object_count_wider)
		local player_near = false
		local mobs = 0
		for  _,obj in ipairs(minetest.env:get_objects_inside_radius(pos, 30)) do
			if obj:is_player() then
				player_near = true
			else
				if obj:get_luaentity().name == "fnaf:balloon_boy" then mobs = mobs + 1 end
			end
		end
		if player_near then
			if mobs < 8 then
				pos.x = pos.x+1
				local p = minetest.find_node_near(pos, 5, {"air"})
				--p.y = p.y+1
				local ll = minetest.env:get_node_light(p)
				local wtime = minetest.env:get_timeofday()
				if not ll then return end
				if ll > 20 then return end
				if ll < 8 then return end
				if minetest.env:get_node(p).name ~= "air" then return end
				p.y = p.y+1
				if minetest.env:get_node(p).name ~= "air" then return end
				if (wtime > 0.2 and wtime < 0.805) and pos.y > 0 then return end
				p.y = p.y-1
				minetest.env:add_entity(p, "fnaf:balloon_boy")
			end
		end
	end
})
